C     (C) 2008-2009 D. V. Wiebe
C
C     CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     This file is part of the GetData project.
C
C     GetData is free software; you can redistribute it and/or modify it under
C     the terms of the GNU Lesser General Public License as published by the
C     Free Software Foundation; either version 2.1 of the License, or (at your
C     option) any later version.
C    
C     GetData is distributed in the hope that it will be useful, but WITHOUT
C     ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
C     FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
C     License for more details.
C    
C     You should have received a copy of the GNU Lesser General Public License
C     along with GetData; if not, write to the Free Software Foundation, Inc.,
C     51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
C

C     Fortran 77 parameters for getdata.  This file defines handy
C     constants useful to Fortran programs

      
C     Error codes
C     Corresponding to GD_E_OK
      INTEGER GD_EOK
      PARAMETER (GD_EOK=0)
C     Corresponding to GD_E_OPEN
      INTEGER GD_EOP
      PARAMETER (GD_EOP=1)
C     Corresponding to GD_E_FORMAT
      INTEGER GD_EFO
      PARAMETER (GD_EFO=2)
C     Corresponding to GD_E_TRUNC
      INTEGER GD_ETR
      PARAMETER (GD_ETR=3)
C     Corresponding to GD_E_CREAT
      INTEGER GD_ECR
      PARAMETER (GD_ECR=4)
C     Corresponding to GD_E_BAD_CODE
      INTEGER GD_EBC
      PARAMETER (GD_EBC=5)
C     Corresponding to GD_E_BAD_TYPE
      INTEGER GD_EBT
      PARAMETER (GD_EBT=6)
C     Corresponding to GD_E_RAW_IO
      INTEGER GD_ERW
      PARAMETER (GD_ERW=7)
C     Corresponding to GD_E_OPEN_INCLUDE
      INTEGER GD_EOI
      PARAMETER (GD_EOI=8)
C     Corresponding to GD_E_INTERNAL_ERROR
      INTEGER GD_EIE
      PARAMETER (GD_EIE=9)
C     Corresponding to GD_E_ALLOC
      INTEGER GD_EAL
      PARAMETER (GD_EAL=10)
C     Corresponding to GD_E_RANGE
      INTEGER GD_ERA
      PARAMETER (GD_ERA=11)
C     Corresponding to GD_E_OPEN_LINFILE
      INTEGER GD_EOL
      PARAMETER (GD_EOL=12)
C     Corresponding to GD_E_RECURSE_LEVEL
      INTEGER GD_ERL
      PARAMETER (GD_ERL=13)
C     Corresponding to GD_E_BAD_DIRFILE
      INTEGER GD_EBD
      PARAMETER (GD_EBD=14)
C     Corresponding to GD_E_BAD_FIELD_TYPE
      INTEGER GD_EBF
      PARAMETER (GD_EBF=15)
C     Corresponding to GD_E_ACCMODE
      INTEGER GD_EAC
      PARAMETER (GD_EAC=16)
C     Corresponding to GD_E_UNSUPPORTED
      INTEGER GD_UNS
      PARAMETER (GD_UNS=17)
C     Corresponding to GD_E_BAD_ENTRY
      INTEGER GD_EBE
      PARAMETER (GD_EBE=19)
C     Corresponding to GD_E_DUPLICATE
      INTEGER GD_EDU
      PARAMETER (GD_EDU=20)
C     Corresponding to GD_E_DIMENSION
      INTEGER GD_EDM
      PARAMETER (GD_EDM=21)
C     Corresponding to GD_E_BAD_INDEX
      INTEGER GD_EBI
      PARAMETER (GD_EBI=22)
C     Corresponding to GD_E_BAD_SCALAR
      INTEGER GD_EBS
      PARAMETER (GD_EBS=23)
C     Corresponding to GD_E_BAD_REFERENCE
      INTEGER GD_EBR
      PARAMETER (GD_EBR=24)
C     Corresponding to GD_E_PROTECTED
      INTEGER GD_EPT
      PARAMETER (GD_EPT=25)
C     Corresponding to GD_E_DELETE
      INTEGER GD_EDL
      PARAMETER (GD_EDL=26)
C     Corresponding to GD_E_BAD_ENDIANNESS
      INTEGER GD_EEN
      PARAMETER (GD_EEN=27)
C     Corresponding to GD_E_CALLBACK
      INTEGER GD_ECB
      PARAMETER (GD_ECB=28)
C     Corresponding to GD_E_BAD_PROTECTION
      INTEGER GD_EBP
      PARAMETER (GD_EBP=29)
C     Corresponding to GD_E_UNCLEAN_DB
      INTEGER GD_UCL
      PARAMETER (GD_UCL=30)
C     Corresponding to GD_E_DOMAIN
      INTEGER GD_EDO
      PARAMETER (GD_EDO=31)
C     Corresponding to GD_E_BAD_REPR
      INTEGER GD_ERP
      PARAMETER (GD_ERP=32)

C Open flags
C     Corresponding to GD_RDONLY
      INTEGER GD_RO
      PARAMETER (GD_RO=0)
C     Corresponding to GD_RDWR
      INTEGER GD_RW
      PARAMETER (GD_RW=1)
C     Corresponding to GD_FORCE_ENDIAN
      INTEGER GD_FE
      PARAMETER (GD_FE=2)
C     Corresponding to GD_BIG_ENDIAN
      INTEGER GD_BE
      PARAMETER (GD_BE=4)
C     Corresponding to GD_LITTLE_ENDIAN
      INTEGER GD_LE
      PARAMETER (GD_LE=8)
C     Corresponding to GD_CREAT
      INTEGER GD_CR
      PARAMETER (GD_CR=16)
C     Corresponding to GD_EXCL
      INTEGER GD_EX
      PARAMETER (GD_EX=32)
C     Corresponding to GD_TRUNC
      INTEGER GD_TR
      PARAMETER (GD_TR=64)
C     Corresponding to GD_PEDANTIC
      INTEGER GD_PE
      PARAMETER (GD_PE=128)
C     Corresponding to GD_FORCE_ENCODING
      INTEGER GD_FC
      PARAMETER (GD_FC=256)
C     Corresponding to GD_VERBOSE
      INTEGER GD_VB
      PARAMETER (GD_VB=512)
C     Corresponding to GD_IGNORE_DUPS
      INTEGER GD_ID
      PARAMETER (GD_ID=1024)
C     Corresponding to GD_IGNORE_REFS
      INTEGER GD_IR
      PARAMETER (GD_IR=2048)
C     Corresponding to GD_PRETTY_PRINT
      INTEGER GD_PP
      PARAMETER (GD_PP=4096)
C     Corresponding to GD_AUTO_ENCODED
      INTEGER GD_EA
      PARAMETER (GD_EA=0)
C     Corresponding to GD_UNENCODED
      INTEGER GD_EN
      PARAMETER (GD_EN=16777216)
C     Corresponding to GD_TEXT_ENCODED
      INTEGER GD_ET
      PARAMETER (GD_ET=33554432)
C     Corresponding to GD_SLIM_ENCODED
      INTEGER GD_ES
      PARAMETER (GD_ES=50331648)
C     Corresponding to GD_GZIP_ENCODED
      INTEGER GD_EG
      PARAMETER (GD_EG=67108864)
C     Corresponding to GD_BZIP2_ENCODED
      INTEGER GD_EB
      PARAMETER (GD_EB=83886080)
C     Corresponding to GD_LZMA_ENCODED
      INTEGER GD_EL
      PARAMETER (GD_EL=100663296)

C Field types
C     Corresponding to GD_NO_ENTRY
      INTEGER GD_NOE
      PARAMETER (GD_NOE=0)
C     Corresponding to GD_RAW_ENTRY
      INTEGER GD_RWE
      PARAMETER (GD_RWE=1)
C     Corresponding to GD_LINCOM_ENTRY
      INTEGER GD_LCE
      PARAMETER (GD_LCE=2)
C     Corresponding to GD_LINTERP_ENTRY
      INTEGER GD_LTE
      PARAMETER (GD_LTE=3)
C     Corresponding to GD_BIT_ENTRY
      INTEGER GD_BTE
      PARAMETER (GD_BTE=4)
C     Corresponding to GD_MULTIPLY_ENTRY
      INTEGER GD_MTE
      PARAMETER (GD_MTE=5)
C     Corresponding to GD_PHASE_ENTRY
      INTEGER GD_PHE
      PARAMETER (GD_PHE=6)
C     Corresponding to GD_INDEX_ENTRY
      INTEGER GD_IXE
      PARAMETER (GD_IXE=7)
C     Corresponding to GD_POLYNOM_ENTRY
      INTEGER GD_PNE
      PARAMETER (GD_PNE=8)
C     Corresponding to GD_SBIT_ENTRY
      INTEGER GD_SBE
      PARAMETER (GD_SBE=9)
C     Corresponding to GD_CONST_ENTRY
      INTEGER GD_COE
      PARAMETER (GD_COE=16)
C     Corresponding to GD_STRING_ENTRY
      INTEGER GD_STE
      PARAMETER (GD_STE=17)

C Data types -- the unsigned types won't work when passed as
C               a return type, but we keep them anyways, since
C               they might appear as a result of calling GDGERW
C     Corresponding to GD_NULL
      INTEGER GD_NUL
      PARAMETER (GD_NUL=0)
C     Corresponding to GD_UINT8
      INTEGER GD_U8
      PARAMETER (GD_U8=1)
C     Corresponding to GD_INT8
      INTEGER GD_I8
      PARAMETER (GD_I8=33)
C     Corresponding to GD_UINT16
      INTEGER GD_U16
      PARAMETER (GD_U16=2)
C     Corresponding to GD_INT16
      INTEGER GD_I16
      PARAMETER (GD_I16=34)
C     Corresponding to GD_UINT32
      INTEGER GD_U32
      PARAMETER (GD_U32=4)
C     Corresponding to GD_INT32
      INTEGER GD_I32
      PARAMETER (GD_I32=36)
C     Corresponding to GD_UINT64
      INTEGER GD_U64
      PARAMETER (GD_U64=8)
C     Corresponding to GD_INT64
      INTEGER GD_I64
      PARAMETER (GD_I64=40)
C     Corresponding to GD_FLOAT32
      INTEGER GD_F32
      PARAMETER (GD_F32=132)
C     Corresponding to GD_FLOAT64
      INTEGER GD_F64
      PARAMETER (GD_F64=136)
C     Corresponding to GD_COMPLEX64
      INTEGER GD_C64
      PARAMETER (GD_C64=264)
C     Corresponding to GD_COMPLEX128
      INTEGER GDC128
      PARAMETER (GDC128=272)

C Delete flags
C     Corresponding to GD_DEL_META
      INTEGER GDD_MT
      PARAMETER (GDD_MT=1)
C     Corresponding to GD_DEL_DATA
      INTEGER GDD_DT
      PARAMETER (GDD_DT=2)
C     Corresponding to GD_DEL_DEREF
      INTEGER GDD_DR
      PARAMETER (GDD_DR=4)
C     Corresponding to GD_DEL_FORCE
      INTEGER GDD_FO
      PARAMETER (GDD_FO=8)

C Protection levels
C     Corresponding to GD_PROTECT_NONE
      INTEGER GDPR_N
      PARAMETER (GDPR_N=0)
C     Corresponding to GD_PROTECT_FORMAT
      INTEGER GDPR_F
      PARAMETER (GDPR_F=1)
C     Corresponding to GD_PROTECT_DATA
      INTEGER GDPR_D
      PARAMETER (GDPR_D=2)
C     Corresponding to GD_PROTECT_ALL
      INTEGER GDPR_A
      PARAMETER (GDPR_A=3)

C Callback actions
C     Corresponding to GD_SYNTAX_ABORT
      INTEGER GDSX_A
      PARAMETER (GDSX_A=0)
C     Corresponding to GD_SYNTAX_RESCAN
      INTEGER GDSX_S
      PARAMETER (GDSX_S=1)
C     Corresponding to GD_SYNTAX_IGNORE
      INTEGER GDSX_I
      PARAMETER (GDSX_I=2)
C     Corresponding to GD_SYNTAX_CONTINUE
      INTEGER GDSX_C
      PARAMETER (GDSX_C=3)

C Syntax suberrors
C     Corresponding to GD_E_FORMAT_BAD_SPF
      INTEGER GDF_SF
      PARAMETER (GDF_SF=1)
C     Corresponding to GD_E_FORMAT_N_FIELDS
      INTEGER GDF_NF
      PARAMETER (GDF_NF=2)
C     Corresponding to GD_E_FORMAT_N_TOK
      INTEGER GDF_NT
      PARAMETER (GDF_NT=3)
C     Corresponding to GD_E_FORMAT_NUMBITS
      INTEGER GDF_NB
      PARAMETER (GDF_NB=4)
C     Corresponding to GD_E_FORMAT_BITNUM
      INTEGER GDF_BN
      PARAMETER (GDF_BN=5)
C     Corresponding to GD_E_FORMAT_BITSIZE
      INTEGER GDF_SZ
      PARAMETER (GDF_SZ=6)
C     Corresponding to GD_E_FORMAT_CHARACTER
      INTEGER GDF_CH
      PARAMETER (GDF_CH=7)
C     Corresponding to GD_E_FORMAT_BAD_LINE
      INTEGER GDF_LI
      PARAMETER (GDF_LI=8)
C     Corresponding to GD_E_FORMAT_RES_NAME
      INTEGER GDF_RN
      PARAMETER (GDF_RN=9)
C     Corresponding to GD_E_FORMAT_ENDIAN
      INTEGER GDF_EN
      PARAMETER (GDF_EN=10)
C     Corresponding to GD_E_FORMAT_BAD_TYPE
      INTEGER GDF_TY
      PARAMETER (GDF_TY=11)
C     Corresponding to GD_E_FORMAT_BAD_NAME
      INTEGER GDF_NA
      PARAMETER (GDF_NA=12)
C     Corresponding to GD_E_FORMAT_UNTERM
      INTEGER GDF_UM
      PARAMETER (GDF_UM=13)
C     Corresponding to GD_E_FORMAT_METARAW
      INTEGER GDF_MR
      PARAMETER (GDF_MR=14)
C     Corresponding to GD_E_FORMAT_NO_PARENT
      INTEGER GDF_PA
      PARAMETER (GDF_PA=15)
C     Corresponding to GD_E_FORMAT_DUPLICATE
      INTEGER GDF_DU
      PARAMETER (GDF_DU=16)
C     Corresponding to GD_E_FORMAT_LOCATION
      INTEGER GDF_LO
      PARAMETER (GDF_LO=17)
C     Corresponding to GD_E_FORMAT_PROTECT
      INTEGER GDF_PR
      PARAMETER (GDF_PR=18)
C     Corresponding to GD_E_FORMAT_LITERAL
      INTEGER GDF_LT
      PARAMETER (GDF_LT=19)

C Miscellaneous parameters
C     Corresponding to GD_MAX_LINE_LENGTH
      INTEGER GD_MLL
      PARAMETER (GD_MLL=4096)
C     Corresponding to GD_ALL_FRAGMENTS
      INTEGER GD_ALL
      PARAMETER (GD_ALL=-1)
C     Corresponding to DIRFILE_STANDARDS_VERSION
      INTEGER GD_DSV
      PARAMETER (GD_DSV=7)


C Externals
C     Corresponding to dirfile_add_bit(3)
      EXTERNAL GDADBT
C     Corresponding to dirfile_add_clincom(3)
      EXTERNAL GDADCL
C     Corresponding to dirfile_add_const(3)
      EXTERNAL GDADCO
C     Corresponding to dirfile_add_cpolynom(3)
      EXTERNAL GDADCP
C     Corresponding to dirfile_add_lincom(3)
      EXTERNAL GDADLC
C     Corresponding to dirfile_add_linterp(3)
      EXTERNAL GDADLT
C     Corresponding to dirfile_add_multiply(3)
      EXTERNAL GDADMT
C     Corresponding to dirfile_add_phase(3)
      EXTERNAL GDADPH
C     Corresponding to dirfile_add_polynom(3)
      EXTERNAL GDADPN
C     Corresponding to dirfile_add_raw(3)
      EXTERNAL GDADRW
C     Corresponding to dirfile_add_sbit(3)
      EXTERNAL GDADSB
C     Corresponding to dirfile_add_spec(3)
      EXTERNAL GDADSP
C     Corresponding to dirfile_add_string(3)
      EXTERNAL GDADST
C     Correpsonding to dirfile_alter_encoding(3)
      EXTERNAL GDAENC
C     Correpsonding to dirfile_alter_endianness(3)
      EXTERNAL GDAEND
C     Correpsonding to dirfile_alter_frameoffset(3)
      EXTERNAL GDAFOF
C     Correpsonding to dirfile_alter_bit(3)
      EXTERNAL GDALBT
C     Correpsonding to dirfile_alter_clincom(3)
      EXTERNAL GDALCL
C     Correpsonding to dirfile_alter_const(3)
      EXTERNAL GDALCO
C     Correpsonding to dirfile_alter_cpolynom(3)
      EXTERNAL GDALCP
C     Correpsonding to dirfile_alter_lincom(3)
      EXTERNAL GDALLC
C     Correpsonding to dirfile_alter_linterp(3)
      EXTERNAL GDALLT
C     Correpsonding to dirfile_alter_multiply(3)
      EXTERNAL GDALMT
C     Correpsonding to dirfile_alter_phase(3)
      EXTERNAL GDALPH
C     Correpsonding to dirfile_alter_polynom(3)
      EXTERNAL GDALPN
C     Correpsonding to dirfile_alter_raw(3)
      EXTERNAL GDALRW
C     Correpsonding to dirfile_alter_sbit(3)
      EXTERNAL GDALSB
C     Correpsonding to dirfile_alter_spec(3)
      EXTERNAL GDALSP
C     Corresponding to dirfile_parser_callback(3)
      EXTERNAL GDCLBK
C     Corresponding to dirfile_close(3)
      EXTERNAL GDCLOS
C     Corresponding to dirfile_copen(3)
      EXTERNAL GDCOPN
C     Check whether an entry contains complex scalars
      EXTERNAL GDCSCL
C     Correpsonding to dirfile_delete(3)
      EXTERNAL GDDELE
C     Corresponding to dirfile_discard(3)
      EXTERNAL GDDSCD
C     Corresponding to get_entry_type(3)
      EXTERNAL GDENTY
C     Returns the dirfile->error member
      EXTERNAL GDEROR
C     Corresponding to get_error_string(3)
      EXTERNAL GDESTR
C     Corresponding to get_field_list_by_type(3) (sort of)
      EXTERNAL GDFDNT
C     Returns the maximum field name length
      EXTERNAL GDFDNX
C     Corresponding to get_field_list(3) (sort of)
      EXTERNAL GDFLDN
C     Corresponding to dirfile_flush(3)
      EXTERNAL GDFLSH
C     Corresponding to get_framenum_subset(3)
      EXTERNAL GDFNSS
C     Corresponding to get_framenum(3)
      EXTERNAL GDFNUM
C     Corresponding to get_fragment_index(3)
      EXTERNAL GDFRGI
C     Corresponding to get_fragmentname(3)
      EXTERNAL GDFRGN
C     Corresponding to get_entry(3) for BIT fields
      EXTERNAL GDGEBT
C     Corresponding to get_entry(3) for complex valued LINCOM fields
      EXTERNAL GDGECL
C     Corresponding to get_entry(3) for CONST fields
      EXTERNAL GDGECO
C     Corresponding to get_entry(3) for complex valued POLYNOM fields
      EXTERNAL GDGECP
C     Corresponding to get_entry(3) for LINCOM fields
      EXTERNAL GDGELC
C     Corresponding to get_entry(3) for LINTERP fields
      EXTERNAL GDGELT
C     Corresponding to get_entry(3) for MULTIPLY fields
      EXTERNAL GDGEMT
C     Corresponding to get_encoding(3)
      EXTERNAL GDGENC
C     Corresponding to get_endianness(3)
      EXTERNAL GDGEND
C     Corresponding to get_entry(3) for PHASE fields
      EXTERNAL GDGEPH
C     Corresponding to get_entry(3) for POLYNOM fields
      EXTERNAL GDGEPN
C     Corresponding to get_entry(3) for RAW fields
      EXTERNAL GDGERW
C     Corresponding to get_entry(3) for SBIT fields
      EXTERNAL GDGESB
C     Corresponding to getdata(3)
      EXTERNAL GDGETD
C     Correpsonding to get_frameoffset(3)
      EXTERNAL GDGFOF
C     Corresponding to get_protection(3)
      EXTERNAL GDGPRT
C     Corresponding to get_reference(3)
      EXTERNAL GDGREF
C     Corresponding to get_spf(3)
      EXTERNAL GDGSPF
C     Corresponding to get_constant(3)
      EXTERNAL GDGTCO
C     Corresponding to get_string(3)
      EXTERNAL GDGTST
C     Corresponding to dirfile_include(3)
      EXTERNAL GDINCL
C     Corresponding to dirfile_madd_bit(3)
      EXTERNAL GDMDBT
C     Corresponding to complex valued dirfile_madd_clincom(3)
      EXTERNAL GDMDCL
C     Corresponding to dirfile_madd_const(3)
      EXTERNAL GDMDCO
C     Corresponding to dirfile_madd_cpolynom(3)
      EXTERNAL GDMDCP
C     Corresponding to dirfile_madd_lincom(3)
      EXTERNAL GDMDLC
C     Corresponding to dirfile_madd_linterp(3)
      EXTERNAL GDMDLT
C     Corresponding to dirfile_madd_multiply(3)
      EXTERNAL GDMDMT
C     Corresponding to dirfile_madd_phase(3)
      EXTERNAL GDMDPH
C     Corresponding to dirfile_madd_polynom(3)
      EXTERNAL GDMDPN
C     Corresponding to dirfile_madd_sbit(3)
      EXTERNAL GDMDSB
C     Corresponding to dirfile_madd_spec(3)
      EXTERNAL GDMDSP
C     Corresponding to dirfile_madd_string(3)
      EXTERNAL GDMDST
C     Corresponding to get_mfield_list(3) (sort of)
      EXTERNAL GDMFDN
C     Corresponding to get_mfield_list_by_type(3) (sort of)
      EXTERNAL GDMFDT
C     Corresponding to dirfile_metaflush(3)
      EXTERNAL GDMFLS
C     Returns the maximum field name length for a meta field list
      EXTERNAL GDMFNX
C     Correpsonding to dirfile_malter_spec(3)
      EXTERNAL GDMLSP
C     Correpsonding to dirfile_move(3)
      EXTERNAL GDMOVE
C     Corresponding to get_mvector_list(3) (sort of)
      EXTERNAL GDMVEN
C     Corresponding to dirfilename(3)
      EXTERNAL GDNAME
C     Corresponding to get_nfields_by_type(3)
      EXTERNAL GDNFDT
C     Corresponding to get_nfields(3)
      EXTERNAL GDNFLD
C     Corresponding to get_nfragments(3)
      EXTERNAL GDNFRG
C     Corresponding to get_nframes(3)
      EXTERNAL GDNFRM
C     Corresponding to get_nmfields(3)
      EXTERNAL GDNMFD
C     Corresponding to get_nmfields_by_type(3)
      EXTERNAL GDNMFT
C     Corresponding to get_nmvectors(3)
      EXTERNAL GDNMVE
C     Corresponding to get_native_type(3)
      EXTERNAL GDNTYP
C     Corresponding to get_nvectors(3)
      EXTERNAL GDNVEC
C     Corresponding to dirfile_open(3)
      EXTERNAL GDOPEN
C     Corresponding to get_parent_fragment(3)
      EXTERNAL GDPFRG
C     Corresponding to dirfile_protect(3)
      EXTERNAL GDPROT
C     Corresponding to put_constant(3)
      EXTERNAL GDPTCO
C     Corresponding to put_string(3)
      EXTERNAL GDPTST
C     Corresponding to putdata(3)
      EXTERNAL GDPUTD
C     Corresponding to dirfile_reference(3)
      EXTERNAL GDREFE
C     Correpsonding to dirfile_rename(3)
      EXTERNAL GDRENM
C     Corresponding to get_raw_filename(3)
      EXTERNAL GDRWFN
C     Corresponding to dirfile_uninclude(3)
      EXTERNAL GDUINC
C     Corresponding to get_vector_list(3) (sort of)
      EXTERNAL GDVECN
C     Corresponding to dirfile_validate(3)
      EXTERNAL GDVLDT
